// Demo2.java
//
// graphical interface to test
//		Audio.jar
//		SoundBite.dll
//




import java.io.*;
import java.awt.*;
import java.awt.event.*;

import Audio.*;		// Audio, SampleRate


class Demo2 extends Frame
{
    private TextField filename_textfield;
    private Button load_button;
    private Button record_button;
    private Button play_button;
    private SoundBite s = null;

    public Demo2()
    {
        super("Demo2");

		//-------------------------
		// setup look
		//-------------------------
        filename_textfield = new TextField("chimes.wav", 50);
        load_button = new Button("Load");
        record_button = new Button("Record");
        play_button = new Button("Play");

        setLayout(new FlowLayout());

        add(filename_textfield);
        add(load_button);
        add(record_button);
        add(play_button);

        pack();
		//-------------------------

		//-------------------------
		// setup event handlers
		//-------------------------
		// respond to window close
		addWindowListener(new WindowAdapter() {
    			public void windowClosing(WindowEvent e) {

					// cleanup ..
					dispose();

    	    		System.exit(0);
    			}
			});

		// filename_textfield - ignore events

		// on load button
		load_button.addActionListener(new ActionListener() {
    			public void actionPerformed(ActionEvent e) {

					// retreive filename in filename_textfield ..
        			String string = filename_textfield.getText();

        			try {
						// empty earlier audio ..
            			if (s != null) {
                			s.dispose();
                			s = null;
            			}
            			s = new SoundBite(string);

        			} catch (SoundBiteException e2) {
						// ignore ..
        			}
    			}
			});
		// on record button
    	record_button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
        			try {
						// empty earlier audio ..
            			if (s != null) {
                			s.dispose();
                			s = null;
            			}

						// true - 16 bits
						// true - mono
						int	numseconds_torecord = 5;
            			s = new SoundBite(true,
										true,
										SampleRate.R_11025,
										numseconds_torecord * SampleRate.R_11025.toInt());

            			s.recordStart();
						// recording is happening in separate thread ..
						// recordStart() stops earlier playing or recording

        			} catch (SoundBiteException e2) {
						// can ignore
						// or
						// empty audio ..
            			if (s != null) {
							// empty - as if not loaded ..
                			s.dispose();
                			s = null;
            			}
        			}
				}
			});
		// on play button
    	play_button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {

    			    if (s != null) {
						try {

							// if is playing - want to interrupt and play again
							// if is recording - want to interrupt and play
							//		whatever recorded so far

							s.recordStop();		// stop if recording
							//s.playStop();		// don't really need this
												// s.playStart() will stop earlier playing ..
												
							s.recordWaitForGet();	// since stopped recording
													// will not wait ..
													// but just get data from
													// internal buffers
			        		s.playStart();
							// playing is happening in separate thread ..
							// playStart() stops earlier playing or recording

	        			} catch (SoundBiteException e2) {
							// ignore ..
	        			}
					}
					// else not do anything
				}
			});
		//-------------------------

        setVisible(true);
    }

    public void dispose()
    {
        if (s != null) {
            s.dispose();
            s = null;
        }
        super.dispose();
    }

    protected void finalize()
        throws Throwable
    {
        dispose();
        super.finalize();
    }

	public static void main(String[] args) {
		// doing a dummy call to SoundBite ..
		// so shareware reminder window appears and is closed
		// before we start everything else ..
		//
		// otherwise may confuse with other windows you generate later
		//
		try {
			SoundBite	s = new SoundBite(false, false, SampleRate.R_11025, 10);
			s.dispose();
		} catch (SoundBiteException e) {
			// ignore
		}
		//
		// after you have clicked on the shareware reminder window
		// the Demo2 frame doesn't automatically appear on top
		//
		// user should select Demo2 frame using the mouse
		// from the start menu bar in Window 95
		// or use Alt-Tab to switch to it ..
		//

		Demo2	d = new Demo2();
	}
}

